function EsoPL_doubleNamesChampion(EsoPL)
	if EsoPL:GetLanguage() == "pl" then
		local rsd = EsoPL.Settings.Data
		
		local GetChampionSkillNameOld = GetChampionSkillName
	
		function GetChampionSkillName(...)
			local championSkillId = ...
			local abilityId = GetChampionAbilityId(championSkillId)
			local polName = GetChampionSkillNameOld(...)
			
			if EsoPL.Settings.ShowChampionTooltip == "pl" or not abilityId then
				return polName
			end
			
			if not abilityId or not rsd.Abilities[abilityId] then
				return polName
			end
			
			if EsoPL.Settings.ShowChampionTooltip == "plen" then
				return string.format("%s (%s)", polName, rsd.Abilities[abilityId])
			elseif EsoPL.Settings.ShowChampionTooltip == "enpl" then
				return string.format("%s (%s)", rsd.Abilities[abilityId], polName)
			else
				return EsoPL.Settings.Data.Abilities[abilityId]
			end
		end
		
		-- Tooltips
		
		local function getIdFromSkillId(championSkillId)
			local abilityId = GetChampionAbilityId(championSkillId)
			local polName = GetChampionSkillNameOld(championSkillId)
			
			return abilityId, polName
		end
		
		local function getIdFromAbilityId(abilityId)
			local polName = GetAbilityName(abilityId)
			
			return abilityId, polName
		end
		
		local function modifyTooltip(abilityId, polName)
			
			local finalName
			
			if EsoPL.Settings.ShowChampionTooltip ~= "pl" and abilityId and rsd.Abilities[abilityId] and polName then					
				if EsoPL.Settings.ShowChampionTooltip == "plen" then
					finalName = string.format("%s (%s)", polName, rsd.Abilities[abilityId])
				elseif EsoPL.Settings.ShowChampionTooltip == "enpl" then
					finalName = string.format("%s (%s)", rsd.Abilities[abilityId], polName)
				else
					finalName = rsd.Abilities[abilityId]
				end
				
				if finalName then
					SafeAddString(SI_ABILITY_TOOLTIP_NAME, finalName, 10)
				end
			end
		end
		
		local function abilityTooltipHook(tooltipControl, method, linkFunc)
			local origMethod = tooltipControl[method]
			tooltipControl[method] = function(self, ...)
				
				modifyTooltip(linkFunc(...))
				
				origMethod(self, ...)
				
				SafeAddString(SI_ABILITY_TOOLTIP_NAME, EsoPL.StringsBackup["SI_ABILITY_TOOLTIP_NAME"], 10)
			end
		end
		
		abilityTooltipHook(ChampionSkillTooltip, "SetChampionSkill", getIdFromSkillId)
		abilityTooltipHook(ChampionSkillTooltip, "SetAbilityId", getIdFromAbilityId)
		ZO_PreHook(CHAMPION_PERKS, "LayoutRightTooltipChampionSkillAbility", function(tooltip, ...)   modifyTooltip(...) end)
		ZO_PostHook(CHAMPION_PERKS, "LayoutRightTooltipChampionSkillAbility", function() SafeAddString(SI_ABILITY_TOOLTIP_NAME, finalName, 10) end)
	end
	EsoPL_doubleNamesChampion = nil
end